#include "FBullCowGame.h"
#include <iostream>
#include <time.h>
#include <stdio.h> 
#include <stdlib.h>
#include <map>
#define TMap std::map
using int32 = int;
using FString = std::string;
FBullCowGame::FBullCowGame()
{
    Reset();
}

void FBullCowGame::Reset()
{
    FString THiddenWord[]={"air","and","ant","brig","bios","macro","savior","orgiac","isogram","milk","father","mother","friend"};
    
    MyCurrentTry = 1;
    srand (time(NULL));
    const FString Hidden_word = 
    (THiddenWord[(int)rand()%12]);
    MyHiddenWord = Hidden_word;

    bGameIsWon = false;
}
int32 FBullCowGame::GetHiddenWordLength() const
{
    return MyHiddenWord.length();
}
int32 FBullCowGame::GetMaxTries() const
{
    TMap<int32, int32> wordLengthToMaxTries{{3, 4}, {4, 7}, {5, 10}, {6, 16}, {7, 20}};

    return wordLengthToMaxTries[MyHiddenWord.length()];
}
// make it not change at all
int32 FBullCowGame::GetCurrentTry() const { return MyCurrentTry; }
bool FBullCowGame::IsGameWon() const
{
    return bGameIsWon;
}
EGuessStatus FBullCowGame::CkeckGuessValidity(FString Guess) const
{
    if (!IsIsogram(Guess))
    {
        return EGuessStatus::Not_Isogram;
    }
    else if (!IsLowerCase(Guess))
    {
        return EGuessStatus::Not_lower_case;
        /* code */
    }
    else if (GetHiddenWordLength() != Guess.length())
    {
        return EGuessStatus::Not_the_same_length;
    }
    else
    {
        return EGuessStatus::ok;
    }
}

FBullCowCount FBullCowGame::SubmitValidGuess(FString Guess)
{
    MyCurrentTry++;
    int32 WordLength = MyHiddenWord.length();
    FBullCowCount BullCowCount;
    for (int32 MHWChar = 0; MHWChar < WordLength; MHWChar++)
    {
        for (int32 GChar = 0; GChar < WordLength; GChar++)
        {

            //(MyHiddenWord[MHWChar])==(Guess[GChar])

            if (MyHiddenWord[MHWChar] == Guess[GChar])
            {

                if (MHWChar == GChar)
                {
                    /* code */ BullCowCount.Bulls++;
                }
                else
                {
                    BullCowCount.Cows++;
                    /* code */
                }
            }

            {
            }
        }
    }

    if (BullCowCount.Bulls == WordLength)
    {
        bGameIsWon = true;
    }
    else
    {
        bGameIsWon = false;
    }

    return BullCowCount;
}
bool FBullCowGame::IsIsogram(FString Word) const
{
    if (Word.length() <= 1)
    {
        return true;
    }
    TMap<char, bool> LetterSeen;

    for (auto Letter : Word)
    {
        Letter = tolower(Letter);
        if (LetterSeen[Letter])
        {
            return false;
        }
        else
        {
            LetterSeen[Letter] = true;
        }
    }

    return true;
}
bool FBullCowGame::IsLowerCase(FString Word) const
{
    if (Word.length() <= 1)
    {
        return true;
    }

    for (auto Letter : Word)
    {

        if (islower(Letter))
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    return true;
}