#pragma once
#include <string>
using FString=std::string;
using int32=int;
struct FBullCowCount
{
	int32 Bulls=0;
	int32 Cows=0;
};
enum class EGuessStatus{Invalid_status,ok,Not_Isogram,Not_the_same_length,Not_lower_case};
class FBullCowGame
{
public:
FBullCowGame();
	void Reset();
	int32 GetMaxTries() const;
	int32 GetCurrentTry()const;
	int32 GetHiddenWordLength()const;
	bool IsGameWon()const;
	EGuessStatus CkeckGuessValidity(FString)const;
	FBullCowCount SubmitValidGuess(FString Guess);
private:
	int32 MyCurrentTry ;

	FString MyHiddenWord;
	bool bGameIsWon;
	bool IsIsogram(FString Word)const;
	bool IsLowerCase(FString Word)const;
};